{% from "bootstrap5/form.html" import quick_form, render_field %}
{% extends "base.html" %}
{% block title %}IBERT{% endblock %}
{% block content %}

<!-- <div class="container"> -->
<h2>IBERT test</h2>

{% if ibert_form.errors %}
	<div class="alert alert-danger">
	  <ul>
		{% for field, field_error in ibert_form.errors.items() %}
		<li>{{ibert_form[field].label.text}} - {{"; ".join(field_error)}}</li>
		{% endfor %}
	  </ul>
	</div>
{% endif %}

<form class="form" method="post" role="form">
  {{ ibert_form.hidden_tag() }}

<!-- IBERT test results -->
<table class="table table-striped">
  <thead>
    <tr>
      <th scope="col">Link</th>
      <th scope="col">TX</th>
      <th scope="col">RX</th>
      <th scope="col">Loopback mode</th>
      <th scope="col">Status</th>
      <th scope="col">Errors</th>
      <th scope="col">BER</th>
      <th scope="col">TX Pattern</th>
      <th scope="col">RX Pattern</th>
      <th scope="col">TX Pre-cursor</th>
      <th scope="col">TX Post-cursor</th>
      <th scope="col">TX Diff. Swing</th>
      <th scope="col">Termination voltage</th>
    </tr>
  </thead>
  <tbody>

{% for link_name, data in ibert.items() %}
    {% if "error" in data %}
    <tr class="table-warning">
      <th scope="row">{{ link_name }}</th>
      <td colspan="12">{{ data["error"] }}</td>
    </tr>
    {% else %}
    <tr>
        <th scope="row">{{ link_name }}</th>
        <td>{{ data["TX_ENDPOINT"] }}</td>
        <td>{{ data["RX_ENDPOINT"] }}</td>
        <td>{{ ibert_form["{}.RX_LOOPBACK".format(link_name)] }}</td>
        <td>{{ data["RX_STATUS"] }}</td>
        <td>{{ data["RX_PRBS_ERR_CNT"] }}</td>
        <td>{{ "{:.2e}".format(data["RX_PRBS_BER"] | float) }}</td>
        <td>{{ ibert_form["{}.TX_PATTERN".format(link_name)] }}</td>
        <td>{{ ibert_form["{}.RX_PATTERN".format(link_name)] }}</td>
        <td>{{ ibert_form["{}.TX_PRE_CURSOR".format(link_name)] }}</td>
        <td>{{ ibert_form["{}.TX_POST_CURSOR".format(link_name)] }}</td>
        <td>{{ ibert_form["{}.TX_DIFF_CTRL".format(link_name)] }}</td>
        <td>{{ ibert_form["{}.RX_TERMINATION_VOLTAGE".format(link_name)] }}</td>
    </tr>
    {% endif %}
{% endfor %}

  </tbody>
</table>


  <div class="row">
    <div class="col-auto g-2">
      <button class="btn btn-primary" type="submit" formaction="/ibert/configure">Apply settings</button>
    </div>  

    <div class="col-auto g-2">
      <button class="btn btn-primary" type="submit" formaction="/ibert/tx_reset">Reset TX</button>
    </div>

    <div class="col-auto g-2">
      <button class="btn btn-primary" type="submit" formaction="/ibert/rx_reset">Reset RX</button>
    </div>
  </div>

</form>


{% endblock %}